/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mabna.pg.bill;

import cnpg.web.ws.token.bill.BillTokenDTO;
import cnpg.web.ws.token.bill.TokenResponse;
import com.mabna.pg.crypto.CNPGSignEncryption;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import sun.misc.BASE64Encoder;

/**
 *
 * @author ssepasi
 */
public class billPayment {
    
    
    private String TOKEN, MID, TID, CRN, AMOUNT, PAYMENTID, BILLID;

    char[] chars = "abcdefghijklmnopqrstuvwxyz".toCharArray();

    StringBuilder sb = null;
    Random random = new Random();

    public String genCrn() {
        sb = new StringBuilder();
        for (int i = 0; i < 8; i++) {
            char c = chars[random.nextInt(chars.length)];
            sb.append(c);
        }
        return sb.toString();
    }

    public void getToken() {
        try {
            Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
            rsa.init(Cipher.ENCRYPT_MODE, CNPGSignEncryption.publicKeyEncryption());
            BillTokenDTO tokenRequest = new BillTokenDTO();

            String CRN = genCrn();
            String RFADDR = "http://localhost/result.xhtml";

            byte[] encrAmount = rsa.doFinal(AMOUNT.getBytes());
            byte[] encrCRN = rsa.doFinal(CRN.getBytes());
            byte[] encrMID = rsa.doFinal(MID.getBytes());
            byte[] encrReferaladress = rsa.doFinal(RFADDR.getBytes());
            byte[] encrTID = rsa.doFinal(TID.getBytes());
            byte[] billID = rsa.doFinal(BILLID.getBytes());
            byte[] payID = rsa.doFinal(PAYMENTID.getBytes());

            tokenRequest.setAMOUNT(new BASE64Encoder().encode(encrAmount));
            tokenRequest.setCRN(new BASE64Encoder().encode(encrCRN));
            tokenRequest.setMID(new BASE64Encoder().encode(encrMID));
            tokenRequest.setTID(new BASE64Encoder().encode(encrTID));
            tokenRequest.setREFERALADRESS(new BASE64Encoder().encode(encrReferaladress));
            tokenRequest.setBILLID(new BASE64Encoder().encode(billID));
            tokenRequest.setPAYMENTID(new BASE64Encoder().encode(payID));

            String signature = BILLID + PAYMENTID + AMOUNT + CRN + MID + RFADDR + TID;

            byte[] encrSignature = CNPGSignEncryption.signData(signature.getBytes(), CNPGSignEncryption.privateKeyEncryption());
            tokenRequest.setSIGNATURE(new BASE64Encoder().encode(encrSignature));

            TokenResponse tokenResponse = reservation(tokenRequest);
            if (tokenResponse.getResult() == 0) {
                TOKEN = tokenResponse.getToken();
                System.out.println(TOKEN);
            } else {
                System.out.println(tokenResponse.getResult());
               
            }

        } catch (NoSuchAlgorithmException | NoSuchPaddingException | InvalidKeyException | IllegalBlockSizeException | BadPaddingException ex) {
            Logger.getLogger(billPayment.class.getName()).log(Level.SEVERE, null, ex);
        } catch (Exception ex) {
            Logger.getLogger(billPayment.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public String getTOKEN() {
        return TOKEN;
    }

    public void setTOKEN(String TOKEN) {
        this.TOKEN = TOKEN;
    }

    public String getMID() {
        return MID;
    }

    public void setMID(String MID) {
        this.MID = MID;
    }

    public String getTID() {
        return TID;
    }

    public void setTID(String TID) {
        this.TID = TID;
    }

    public String getCRN() {
        return CRN;
    }

    public void setCRN(String CRN) {
        this.CRN = CRN;
    }

    public String getAMOUNT() {
        return AMOUNT;
    }

    public void setAMOUNT(String AMOUNT) {
        this.AMOUNT = AMOUNT;
    }

    public String getPAYMENTID() {
        return PAYMENTID;
    }

    public void setPAYMENTID(String PAYMENTID) {
        this.PAYMENTID = PAYMENTID;
    }

    public String getBILLID() {
        return BILLID;
    }

    public void setBILLID(String BILLID) {
        this.BILLID = BILLID;
    }

    private static TokenResponse reservation(cnpg.web.ws.token.bill.BillTokenDTO billTokenParam) {
        cnpg.web.ws.token.bill.Token service = new cnpg.web.ws.token.bill.Token();
        cnpg.web.ws.token.bill.BillTokenService port = service.getBillTokenServicePort();
        return port.reservation(billTokenParam);
    }
    
    
    
}
