/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mabna.pg.confirm;

import com.mabna.pg.crypto.CNPGSignEncryption;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import messaging.s2m.ws.ConfirmationDTO;
import messaging.s2m.ws.SaleConfResponse;
import sun.misc.BASE64Encoder;

/**
 *
 * @author ssepasi
 */
public class Confirmation {
    
    
    private String RESCODE, TRN, CRN, AMOUNT, CONFRES, RESULT,MID;

    public String getMID() {
        return MID;
    }

    public void setMID(String MID) {
        this.MID = MID;
    }

    public String getRESCODE() {
        return RESCODE;
    }

    public void setRESCODE(String RESCODE) {
        this.RESCODE = RESCODE;
    }

    public String getTRN() {
        return TRN;
    }

    public void setTRN(String TRN) {
        this.TRN = TRN;
    }

    public String getCRN() {
        return CRN;
    }

    public void setCRN(String CRN) {
        this.CRN = CRN;
    }

    public String getAMOUNT() {
        return AMOUNT;
    }

    public void setAMOUNT(String AMOUNT) {
        this.AMOUNT = AMOUNT;
    }

    public String getCONFRES() {
        return CONFRES;
    }

    public void setCONFRES(String CONFRES) {
        this.CONFRES = CONFRES;
    }

    public String getRESULT() {
        return RESULT;
    }

    public void setRESULT(String RESULT) {
        this.RESULT = RESULT;
    }
    
    public String confirmationAction() {

        if (null != CRN && "00".equals(RESCODE)) {
            try {
                Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
                rsa.init(Cipher.ENCRYPT_MODE, CNPGSignEncryption.publicKeyEncryption());
                byte[] encrCRN = rsa.doFinal(CRN.getBytes());
                byte[] encrTRN = rsa.doFinal(TRN.getBytes());
                byte[] encrMID = rsa.doFinal(MID.getBytes());
                ConfirmationDTO confirmationDTO = new ConfirmationDTO();

                confirmationDTO.setCRN(new BASE64Encoder().encode(encrCRN));
                confirmationDTO.setTRN(new BASE64Encoder().encode(encrTRN));
                confirmationDTO.setMID(new BASE64Encoder().encode(encrMID));

                String signature = MID + TRN + CRN;

                byte[] encrSignature = CNPGSignEncryption.signData(signature.getBytes(), CNPGSignEncryption.privateKeyEncryption());

                confirmationDTO.setSIGNATURE(new BASE64Encoder().encode(encrSignature));

                SaleConfResponse saleConfResponse = sendConfirmation(confirmationDTO);

                if (saleConfResponse.isSuccessful()) {
                    return "confSuccess";     
                } else {
                    return "confDone";
                }
                
            } catch (NoSuchAlgorithmException ex) {
                Logger.getLogger(Confirmation.class.getName()).log(Level.SEVERE, null, ex);
            } catch (NoSuchPaddingException ex) {
                Logger.getLogger(Confirmation.class.getName()).log(Level.SEVERE, null, ex);
            } catch (InvalidKeyException ex) {
                Logger.getLogger(Confirmation.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IllegalBlockSizeException ex) {
                Logger.getLogger(Confirmation.class.getName()).log(Level.SEVERE, null, ex);
            } catch (BadPaddingException ex) {
                Logger.getLogger(Confirmation.class.getName()).log(Level.SEVERE, null, ex);
            } catch (Exception ex) {
                Logger.getLogger(Confirmation.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
        return "";
    }

    private static SaleConfResponse sendConfirmation(messaging.s2m.ws.ConfirmationDTO saleConfReq) {
        messaging.s2m.ws.TransactionReference_Service service = new messaging.s2m.ws.TransactionReference_Service();
        messaging.s2m.ws.TransactionReference port = service.getTransactionReferencePort();
        return port.sendConfirmation(saleConfReq);
    }
    
    
    
}
