package com.mabna.pg.crypto;



import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.logging.Level;
import java.util.logging.Logger;
import sun.misc.BASE64Decoder;

/**
 *
 * 
 * 
 * @author ahaghighi
 */
public class CNPGSignEncryption {

    public static PublicKey publicKeyEncryption() {
   
        PublicKey publicKey2 = null;
        File filePublicKey = new File("e:/pub_server.pem");
        
        FileInputStream fis = null;
        
        try {
            fis = new FileInputStream(filePublicKey);
            byte[] encodedPublicKey = new byte[(int) filePublicKey.length()];
            fis.read(encodedPublicKey);
            fis.close();
            KeyFactory keyFactory = null;
            try {
                keyFactory=KeyFactory.getInstance("RSA");
                byte[] encodedPublicKey2 = new BASE64Decoder().decodeBuffer(new String(encodedPublicKey));
                X509EncodedKeySpec publicKeySpec = new X509EncodedKeySpec(encodedPublicKey2);
                publicKey2 = keyFactory.generatePublic(publicKeySpec);
            } catch (    InvalidKeySpecException | NoSuchAlgorithmException ex) {
            Logger.getLogger(CNPGSignEncryption.class.getName()).log(Level.SEVERE, null, ex);
            }                                    
        } catch (FileNotFoundException ex) {
            Logger.getLogger(CNPGSignEncryption.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(CNPGSignEncryption.class.getName()).log(Level.SEVERE, null, ex);
        }   
        return publicKey2;
    }
    
    public static PrivateKey privateKeyEncryption() {
        PrivateKey privateKey2 = null;
        File filePrivateKey = new File("e:/prv_merch.pem");
        FileInputStream fis = null;
        try {
            fis = new FileInputStream(filePrivateKey);
            byte[] encodedPrivateKey = new byte[(int) filePrivateKey.length()];
            fis.read(encodedPrivateKey);
            fis.close();         
            KeyFactory keyFactory = null;
            try {
                keyFactory=KeyFactory.getInstance("RSA");
                encodedPrivateKey = new BASE64Decoder().decodeBuffer(new String(encodedPrivateKey));
                PKCS8EncodedKeySpec privateKeySpec = new PKCS8EncodedKeySpec(encodedPrivateKey);
                privateKey2 = keyFactory.generatePrivate(privateKeySpec);
            } catch (    InvalidKeySpecException | NoSuchAlgorithmException ex) {
            Logger.getLogger(CNPGSignEncryption.class.getName()).log(Level.SEVERE, null, ex);
            }                                    
        } catch (FileNotFoundException ex) {
            Logger.getLogger(CNPGSignEncryption.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(CNPGSignEncryption.class.getName()).log(Level.SEVERE, null, ex);
        }   
        return privateKey2;
    }
    
    public static byte[] signData(byte[] data, PrivateKey key) throws Exception {
        Signature signer = Signature.getInstance("SHA1withRSA");
        signer.initSign(key);
        signer.update(data);
        return (signer.sign());
    }
    
    public static boolean verifySig(byte[] data, PublicKey key, byte[] sig) throws Exception {
        Signature signer = Signature.getInstance("SHA1withRSA");
        signer.initVerify(key);
        signer.update(data);
        return (signer.verify(sig));

    }
}
